#ifndef CLASS_PACKET
#define CLASS_PACKET

#include "../Scratch/Scratch.h"
#include "BSEzSock.h"

#ifndef null
#define null 0
#endif

namespace BromScript{
	class Packet{
	public:
		bool Valid;
		EzSock* Sock;
		unsigned int OutPos;
		unsigned int OutSize;
		unsigned int InPos;
		unsigned int InSize;
		unsigned char* InBuffer;
		unsigned char* OutBuffer;

		Packet();
		Packet(EzSock*);
		~Packet();

		void Clear();

		void WriteByte(unsigned char);
		void WriteBool(bool);
		void WriteBytes(unsigned char* arr, int size, bool sendsize);
		void WriteShort(short);
		void WriteUShorts(unsigned short* arr, int size, bool sendsize);
		void WriteInt(int);
		void WriteLong(long long);
		void WriteFloat(float);
		void WriteDouble(double);
		void WriteString(const char*);

		unsigned char ReadByte();
		bool ReadBool();
		unsigned char* ReadBytes(int len);
		short ReadShort();
		int ReadInt();
		long long ReadLong();
		float ReadFloat();
		double ReadDouble();
		Scratch::CString ReadString();

		bool CanRead(int);
		bool HasDataLeft();
		int DataLeft();

		void Send();

		void CheckSpaceOut(int);
		void AllocateMoreSpaceOut(int);
		void CheckSpaceIn(int);
		void AllocateMoreSpaceIn(int);
	};
}

#endif